package api.facturalo.rest;

/**
 * PARA MANEJO DE CONEXIN SIN VALIDACION DE CERTIFICADOS
 */
import java.security.SecureRandom;
import java.security.cert.X509Certificate;
import javax.net.ssl.HttpsURLConnection;
import javax.net.ssl.SSLContext;
import javax.net.ssl.X509TrustManager;

public class Conexion extends ServicioDo {
	public Conexion(String endpoint) {
		url = endpoint.replace("facturaloplus.com", "timbradorxpress.mx");
	}
	
	public Conexion(String endpoint, boolean validateSSL) {
		if (validateSSL) {
			url = endpoint.replace("facturaloplus.com", "timbradorxpress.mx");
		}
		else {
			InstallTrustManager();
			url = endpoint;
		}
	}
	
	public static void InstallTrustManager() {
		// Create a trust manager that does not validate certificate chains
		X509TrustManager[] trustCerts = new X509TrustManager[]{new X509TrustManager(){
		    public X509Certificate[] getAcceptedIssuers(){return null;}
		    public void checkClientTrusted(X509Certificate[] certs, String authType){}
		    public void checkServerTrusted(X509Certificate[] certs, String authType){}
		}};

		// Install the all-trusting trust manager
		try {
		    SSLContext sc = SSLContext.getInstance("TLS");
		    sc.init(null, trustCerts, new SecureRandom());
		    HttpsURLConnection.setDefaultSSLSocketFactory(sc.getSocketFactory());
		} catch (Exception e) {
		    e.printStackTrace();
		}
	}
}
